libvtemm: Gnome::Vte::Terminal Class Reference

libvtemm 0.25.0

- Main Page
- Related Pages
- Modules
- Classes
- Examples

- Class List
- Class Hierarchy
- Class Members

Public Types | Public Member Functions | Static Public Member Functions | Related Functions
Gnome::Vte::Terminal Class Reference

Terminal - a terminal emulator implemented as a gtkmm widget. More...

`#include <libvtemm/terminal.h>`

Inheritance diagram for Gnome::Vte::Terminal:
[legend]

List of all members.

## Public Types
typedef sigc::slot< bool, long, long > | SlotSelectedCallback
| For instance, bool on_selected(long column, long row);.
## Public Member Functions
VteTerminal* | gobj ()
| Provides access to the underlying C GtkObject.
const VteTerminal* | gobj () const
| Provides access to the underlying C GtkObject.
Glib::Pid | fork_command (const std::string& command=std::string(), const StdStringArrayHandle& argv=StdStringArrayHandle(0, Glib::OWNERSHIP_NONE), const StdStringArrayHandle& envv=StdStringArrayHandle(0, Glib::OWNERSHIP_NONE), const std::string& directory=std::string(), bool lastlog=false, bool utmp=false, bool wtmp=false)
| Starts the specified command under a newly-allocated controlling pseudo-terminal.
Glib::Pid | forkpty (const StdStringArrayHandle& envv=StdStringArrayHandle(0, Glib::OWNERSHIP_NONE), const std::string& directory=std::string(), bool lastlog=false, bool utmp=false, bool wtmp=false)
| Starts a new child process under a newly-allocated controlling pseudo-terminal.
void | feed (const Glib::ustring& data)
| Interprets data as if it were data received from a child process.
void | feed_child (const Glib::ustring& text)
| Sends a block of UTF-8 text to the child as if it were entered by the user at the keyboard.
void | feed_child_binary (const std::string& data)
| Sends a block of binary data to the child.
void | copy_clipboard ()
| Places the selected text in the terminal in the `GDK_SELECTION_CLIPBOARD` selection.
void | paste_clipboard ()
| Sends the contents of the `GDK_SELECTION_CLIPBOARD` selection to the terminal's child.
void | copy_primary ()
| Places the selected text in the terminal in the `GDK_SELECTION_PRIMARY` selection.
void | paste_primary ()
| Sends the contents of the `GDK_SELECTION_PRIMARY` selection to the terminal's child.
void | select_all ()
| Selects all text within the terminal (including the scrollback buffer).
void | select_none ()
| Clears the current selection.
void | set_size (long columns, long rows)
| Attempts to change the terminal's size in terms of rows and columns.
void | set_audible_bell (bool is_audible=true)
| Controls whether or not the terminal will beep when the child outputs the "bl" sequence.
bool | get_audible_bell () const
| Checks whether or not the terminal will beep when the child outputs the "bl" sequence.
void | set_visible_bell (bool is_visible=true)
| Controls whether or not the terminal will present a visible bell to the user when the child outputs the "bl" sequence.
bool | get_visible_bell () const
| Checks whether or not the terminal will present a visible bell to the user when the child outputs the "bl" sequence.
void | set_scroll_background (bool scroll=true)
| Controls whether or not the terminal will scroll the background image (if one is set) when the text in the window must be scrolled.
void | set_scroll_on_output (bool scroll=true)
| Controls whether or not the terminal will forcibly scroll to the bottom of the viewable history when the new data is received from the child.
void | set_scroll_on_keystroke (bool scroll=true)
| Controls whether or not the terminal will forcibly scroll to the bottom of the viewable history when the user presses a key.
void | set_color_dim (const Gdk::Color& dim)
| Sets the color used to draw dim text in the default foreground color.
void | set_color_bold (const Gdk::Color& bold)
| Sets the color used to draw bold text in the default foreground color.
void | set_color_foreground (const Gdk::Color& foreground)
| Sets the foreground color used to draw normal text.
void | set_color_background (const Gdk::Color& background)
| Sets the background color for text which does not have a specific background color assigned.
void | set_color_cursor (const Gdk::Color& cursor_background)
| Sets the background color for text which is under the cursor.
void | set_default_color_cursor ()
| Text under the cursor will be drawn with foreground and background colors reversed.
void | set_color_highlight (const Gdk::Color& highlight_background)
| Sets the background color for text which is highlighted.
void | set_default_color_highlight ()
| Highlighted text (which is usually highlighted because it is selected) will be drawn with foreground and background colors reversed.
void | set_colors (const Gdk::Color& foreground, const Gdk::Color& background, const Gdk::ArrayHandle_Color& palette)
| The terminal widget uses a 28-color model comprised of the default foreground and background colors, the bold foreground color, the dim foreground color, an eight color palette, bold versions of the eight color palette, and a dim version of the the eight color palette.
void | set_default_colors ()
| Reset the terminal palette to reasonable compiled-in defaults.
void | set_default_colors (const Gdk::ArrayHandle_Color& palette)
| The terminal widget uses a 28-color model comprised of the default foreground and background colors, the bold foreground color, the dim foreground color, an eight color palette, bold versions of the eight color palette, and a dim version of the the eight color palette.
void | set_background_image (const Glib::RefPtr< Gdk::Pixbuf >& image)
| Sets a background image for the widget.
void | set_background_image_file (const std::string&path)
| Sets a background image for the widget.
void | unset_background_image ()
| Convenience method which cancels background image.
void | set_background_tint_color (const Gdk::Color& color)
| If a background image has been set using set_background_image(), set_background_image_file(), or set_background_transparent(), and the value set by set_background_saturation() is less than one, the terminal will adjust the color of the image before drawing the image.
void | set_background_saturation (double saturation)
| If a background image has been set using set_background_image(), set_background_image_file(), or set_background_transparent(), and the saturation value is less than 1.0, the terminal will adjust the colors of the image before drawing the image.
void | set_background_transparent (bool transparent=true)
| Sets the terminal's background image to the pixmap stored in the root window, adjusted so that if there are no windows below your application, the widget will appear to be transparent.
void | set_opacity (guint16 opacity)
| Sets the opacity of the terminal background, were 0 means completely transparent and 65535 means completely opaque.
void | set_cursor_blink_mode (TerminalCursorBlinkMode mode)
| Sets whether or not the cursor will blink.
TerminalCursorBlinkMode | get_cursor_blink_mode () const
| Gets cursor blink mode.
void | set_cursor_shape (TerminalCursorShape shape)
| Sets the shape of the cursor drawn.
TerminalCursorShape | get_cursor_shape () const
| Gets the shape of the cursor drawn.
void | set_scrollback_lines (long lines)
| Sets the length of the scrollback buffer used by the terminal.
void | im_append_menuitems (Gtk::MenuShell& menushell)
| Appends menu items for various input methods to the given menu.
void | set_font (const Pango::FontDescription& font_desc)
| Sets the font used for rendering all text displayed by the terminal, overriding any fonts set using Gtk::Widget::modify_font().
void | set_font_from_string (const Glib::ustring& name)
| A convenience function which converts name into a Pango::FontDescription and passes it to set_font().
Pango::FontDescription | get_font () const
| Queries the terminal for information about the fonts which will be used to draw text in the terminal.
void | set_allow_bold (bool allow_bold=true)
| Controls whether or not the terminal will attempt to draw bold text, either by using a bold font variant or by repainting text with a different offset.
bool | get_allow_bold () const
| Checks whether or not the terminal will attempt to draw bold text by repainting text with a one-pixel offset.
bool | get_has_selection () const
| Checks if the terminal currently contains selected text.
void | set_word_chars (const Glib::ustring& spec)
| When the user double-clicks to start selection, the terminal will extend the selection on word boundaries.
bool | is_word_char (gunichar c)
| Checks if a particular character is considered to be part of a word or not, based on the values last passed to set_word_chars().
void | set_backspace_binding (TerminalEraseBinding binding)
| Modifies the terminal's backspace key binding, which controls what string or control sequence the terminal sends to its child when the user presses the backspace key.
void | set_delete_binding (TerminalEraseBinding binding)
| Modifies the terminal's delete key binding, which controls what string or control sequence the terminal sends to its child when the user presses the delete key.
void | set_mouse_autohide (bool setting=true)
| Changes the value of the terminal's mouse autohide setting.
bool | get_mouse_autohide () const
| Determines the value of the terminal's mouse autohide setting.
void | reset (bool full, bool clear_history)
| Resets as much of the terminal's internal state as possible, discarding any unprocessed input data, resetting character attributes, cursor state, national character set state, status line, terminal modes (insert/delete), selection state, and encoding.
TextAndCharAttrs | get_text (const SlotSelectedCallback& slot) const
| Extracts a view of the visible part of the terminal.
TextAndCharAttrs | get_text_include_trailing_spaces (const SlotSelectedCallback& slot) const
| Extracts a view of the visible part of the terminal.
TextAndCharAttrs | get_text_range (long start_row, long start_col, long end_row, long end_col, const SlotSelectedCallback& slot) const
| Extracts a view of the visible part of the terminal.
CursorPosition | get_cursor_position () const
| Reads the location of the insertion cursor and returns it.
void | match_clear_all ()
| Clears the list of regular expressions the terminal uses to highlight text when the user moves the mouse cursor.
int | match_add_gregex (Glib::RefPtr< Glib::Regex > regex, Glib::RegexMatchFlags flags)
| Adds the regular expression regex to the list of matching expressions.
void | match_set_cursor (int tag, Gdk::Cursor& cursor)
| Sets which cursor the terminal will use if the pointer is over the pattern specified by tag.
void | match_set_cursor_type (int tag, Gdk::CursorType cursor_type)
| Sets which cursor the terminal will use if the pointer is over the pattern specified by tag.
void | match_set_cursor_name (int tag, const Glib::ustring& cursor_name)
| Sets which cursor the terminal will use if the pointer is over the pattern specified by tag.
void | match_remove (int tag)
| Removes the regular expression which is associated with the given tag from the list of expressions which the terminal will highlight when the user moves the mouse cursor over matching text.
Match | match_check (long column, long row)
| Checks if the text in and around the specified position matches any of the regular expressions previously set using match_add_gregex().
void | set_emulation (const Glib::ustring& emulation)
| Sets what type of terminal the widget attempts to emulate by scanning for control sequences defined in the system's termcap file.
void | set_default_emulation ()
| Sets default type of terminal the widget attempts to emulate.
Glib::ustring | get_emulation () const
| Queries the terminal for its current emulation, as last set by a call to set_emulation().
Glib::ustring | get_default_emulation () const
| Queries the terminal for its default emulation, which is attempted if set_default_emulation() is used.
void | set_encoding (const std::string& codeset)
| Changes the encoding the terminal will expect data from the child to be encoded with.
std::string | get_encoding () const
| Determines the name of the encoding in which the terminal expects data to be encoded.
Glib::ustring | get_status_line () const
| Some terminal emulations specify a status line which is separate from the main display area, and define a means for applications to move the cursor to the status line and back.
Padding | get_padding () const
| Determines the amount of additional space the widget is using to pad the edges of its visible area.
void | set_pty (int pty_master)
| Attach an existing PTY master side to the terminal widget.
int | get_pty () const
| Gets the file descriptor, or -1 if the terminal has no PTY.
Gtk::Adjustment& | get_adjustment ()
| Gets terminal's adjustment for use in scrollbar for example.
const Gtk::Adjustment& | get_adjustment () const
| An accessor function provided for the benefit of language bindings.
long | get_char_width () const
| Gets terminal's char width for use in Gdk::Geometry for example.
long | get_char_height () const
| Gets terminal's char height for use in Gdk::Geometry for example.
long | get_row_count () const
| Gets terminal's row count.
long | get_column_count () const
| Gets terminal's column count.
Glib::ustring | get_window_title () const
| Gets terminal's window title.
Glib::ustring | get_icon_title () const
| Gets terminal's icon title.
int | get_child_exit_status () const
| Gets the exit status of the command started by fork_command().
bool | write_contents (const Glib::RefPtr< Gio::OutputStream >& stream, const Glib::RefPtr< Gio::Cancellable >& cancellable, TerminalWriteFlags flags=TERMINAL_WRITE_DEFAULT)
| Write contents of the current contents of terminal (including any scrollback history) to stream according to flags.
bool | write_contents (const Glib::RefPtr< Gio::OutputStream >& stream, TerminalWriteFlags flags=TERMINAL_WRITE_DEFAULT)
| Write contents of the current contents of terminal (including any scrollback history) to stream according to flags.
Glib::SignalProxy0< void > | signal_eof ()
Glib::SignalProxy0< void > | signal_child_exited ()
Glib::SignalProxy0< void > | signal_emulation_changed ()
Glib::SignalProxy0< void > | signal_encoding_changed ()
Glib::SignalProxy2< void, guint, guint > | signal_char_size_changed ()
Glib::SignalProxy0< void > | signal_window_title_changed ()
Glib::SignalProxy0< void > | signal_icon_title_changed ()
Glib::SignalProxy0< void > | signal_selection_changed ()
Glib::SignalProxy0< void > | signal_contents_changed ()
Glib::SignalProxy0< void > | signal_cursor_moved ()
Glib::SignalProxy0< void > | signal_status_line_changed ()
Glib::SignalProxy0< void > | signal_deiconify_window ()
Glib::SignalProxy0< void > | signal_iconify_window ()
Glib::SignalProxy0< void > | signal_raise_window ()
Glib::SignalProxy0< void > | signal_lower_window ()
Glib::SignalProxy0< void > | signal_refresh_window ()
Glib::SignalProxy0< void > | signal_restore_window ()
Glib::SignalProxy0< void > | signal_maximize_window ()
Glib::SignalProxy2< void, guint, guint > | signal_resize_window ()
Glib::SignalProxy2< void, guint, guint > | signal_move_window ()
Glib::SignalProxy0< void > | signal_increase_font_size ()
Glib::SignalProxy0< void > | signal_decrease_font_size ()
Glib::SignalProxy0< void > | signal_text_modified ()
Glib::SignalProxy0< void > | signal_text_inserted ()
Glib::SignalProxy0< void > | signal_text_deleted ()
Glib::SignalProxy1< void, int > | signal_text_scrolled ()
Glib::SignalProxy0< void > | signal_copy_clipboard ()
Glib::SignalProxy0< void > | signal_paste_clipboard ()
Glib::SignalProxy2< void, Gtk::Adjustment &, Gtk::Adjustment& > | signal_set_scroll_adjustments ()
Glib::SignalProxy0< void > | signal_beep ()
Glib::PropertyProxy< bool > | property_allow_bold ()
| You rarely need to use properties because there are get_ and set_ methods for almost all of them.
Glib::PropertyProxy_ReadOnly < bool > | property_allow_bold () const
| You rarely need to use properties because there are get_ and set_ methods for almost all of them.
Glib::PropertyProxy< bool > | property_audible_bell ()
| You rarely need to use properties because there are get_ and set_ methods for almost all of them.
Glib::PropertyProxy_ReadOnly < bool > | property_audible_bell () const
| You rarely need to use properties because there are get_ and set_ methods for almost all of them.
Glib::PropertyProxy < Glib::ustring > | property_background_image_file ()
| You rarely need to use properties because there are get_ and set_ methods for almost all of them.
Glib::PropertyProxy_ReadOnly < Glib::ustring > | property_background_image_file () const
| You rarely need to use properties because there are get_ and set_ methods for almost all of them.
Glib::PropertyProxy< Gdk::Pixbuf > | property_background_image_pixbuf ()
| You rarely need to use properties because there are get_ and set_ methods for almost all of them.
Glib::PropertyProxy_ReadOnly < Gdk::Pixbuf > | property_background_image_pixbuf () const
| You rarely need to use properties because there are get_ and set_ methods for almost all of them.
Glib::PropertyProxy< double > | property_background_opacity ()
| You rarely need to use properties because there are get_ and set_ methods for almost all of them.
Glib::PropertyProxy_ReadOnly < double > | property_background_opacity () const
| You rarely need to use properties because there are get_ and set_ methods for almost all of them.
Glib::PropertyProxy< double > | property_background_saturation ()
| You rarely need to use properties because there are get_ and set_ methods for almost all of them.
Glib::PropertyProxy_ReadOnly < double > | property_background_saturation () const
| You rarely need to use properties because there are get_ and set_ methods for almost all of them.
Glib::PropertyProxy< Gdk::Color > | property_background_tint_color ()
| You rarely need to use properties because there are get_ and set_ methods for almost all of them.
Glib::PropertyProxy_ReadOnly < Gdk::Color > | property_background_tint_color () const
| You rarely need to use properties because there are get_ and set_ methods for almost all of them.
Glib::PropertyProxy< bool > | property_background_transparent ()
| You rarely need to use properties because there are get_ and set_ methods for almost all of them.
Glib::PropertyProxy_ReadOnly < bool > | property_background_transparent () const
| You rarely need to use properties because there are get_ and set_ methods for almost all of them.
Glib::PropertyProxy < TerminalEraseBinding > | property_backspace_binding ()
| You rarely need to use properties because there are get_ and set_ methods for almost all of them.
Glib::PropertyProxy_ReadOnly < TerminalEraseBinding > | property_backspace_binding () const
| You rarely need to use properties because there are get_ and set_ methods for almost all of them.
Glib::PropertyProxy < TerminalCursorBlinkMode > | property_cursor_blink_mode ()
| You rarely need to use properties because there are get_ and set_ methods for almost all of them.
Glib::PropertyProxy_ReadOnly < TerminalCursorBlinkMode > | property_cursor_blink_mode () const
| You rarely need to use properties because there are get_ and set_ methods for almost all of them.
Glib::PropertyProxy < TerminalCursorShape > | property_cursor_shape ()
| You rarely need to use properties because there are get_ and set_ methods for almost all of them.
Glib::PropertyProxy_ReadOnly < TerminalCursorShape > | property_cursor_shape () const
| You rarely need to use properties because there are get_ and set_ methods for almost all of them.
Glib::PropertyProxy < TerminalEraseBinding > | property_delete_binding ()
| You rarely need to use properties because there are get_ and set_ methods for almost all of them.
Glib::PropertyProxy_ReadOnly < TerminalEraseBinding > | property_delete_binding () const
| You rarely need to use properties because there are get_ and set_ methods for almost all of them.
Glib::PropertyProxy < Glib::ustring > | property_emulation ()
| You rarely need to use properties because there are get_ and set_ methods for almost all of them.
Glib::PropertyProxy_ReadOnly < Glib::ustring > | property_emulation () const
| You rarely need to use properties because there are get_ and set_ methods for almost all of them.
Glib::PropertyProxy < Glib::ustring > | property_encoding ()
| You rarely need to use properties because there are get_ and set_ methods for almost all of them.
Glib::PropertyProxy_ReadOnly < Glib::ustring > | property_encoding () const
| You rarely need to use properties because there are get_ and set_ methods for almost all of them.
Glib::PropertyProxy < Pango::FontDescription > | property_font_desc ()
| You rarely need to use properties because there are get_ and set_ methods for almost all of them.
Glib::PropertyProxy_ReadOnly < Pango::FontDescription > | property_font_desc () const
| You rarely need to use properties because there are get_ and set_ methods for almost all of them.
Glib::PropertyProxy_ReadOnly < Glib::ustring > | property_icon_title () const
| You rarely need to use properties because there are get_ and set_ methods for almost all of them.
Glib::PropertyProxy< bool > | property_pointer_autohide ()
| You rarely need to use properties because there are get_ and set_ methods for almost all of them.
Glib::PropertyProxy_ReadOnly < bool > | property_pointer_autohide () const
| You rarely need to use properties because there are get_ and set_ methods for almost all of them.
Glib::PropertyProxy< int > | property_pty ()
| You rarely need to use properties because there are get_ and set_ methods for almost all of them.
Glib::PropertyProxy_ReadOnly< int > | property_pty () const
| You rarely need to use properties because there are get_ and set_ methods for almost all of them.
Glib::PropertyProxy< bool > | property_scroll_background ()
| You rarely need to use properties because there are get_ and set_ methods for almost all of them.
Glib::PropertyProxy_ReadOnly < bool > | property_scroll_background () const
| You rarely need to use properties because there are get_ and set_ methods for almost all of them.
Glib::PropertyProxy< bool > | property_scroll_on_keystroke ()
| You rarely need to use properties because there are get_ and set_ methods for almost all of them.
Glib::PropertyProxy_ReadOnly < bool > | property_scroll_on_keystroke () const
| You rarely need to use properties because there are get_ and set_ methods for almost all of them.
Glib::PropertyProxy< bool > | property_scroll_on_output ()
| You rarely need to use properties because there are get_ and set_ methods for almost all of them.
Glib::PropertyProxy_ReadOnly < bool > | property_scroll_on_output () const
| You rarely need to use properties because there are get_ and set_ methods for almost all of them.
Glib::PropertyProxy< int > | property_scrollback_lines ()
| You rarely need to use properties because there are get_ and set_ methods for almost all of them.
Glib::PropertyProxy_ReadOnly< int > | property_scrollback_lines () const
| You rarely need to use properties because there are get_ and set_ methods for almost all of them.
Glib::PropertyProxy< bool > | property_visible_bell ()
| You rarely need to use properties because there are get_ and set_ methods for almost all of them.
Glib::PropertyProxy_ReadOnly < bool > | property_visible_bell () const
| You rarely need to use properties because there are get_ and set_ methods for almost all of them.
Glib::PropertyProxy_ReadOnly < Glib::ustring > | property_window_title () const
| You rarely need to use properties because there are get_ and set_ methods for almost all of them.
Glib::PropertyProxy < Glib::ustring > | property_word_chars ()
| You rarely need to use properties because there are get_ and set_ methods for almost all of them.
Glib::PropertyProxy_ReadOnly < Glib::ustring > | property_word_chars () const
| You rarely need to use properties because there are get_ and set_ methods for almost all of them.
## Static Public Member Functions
static bool | always_selected (long, long)
| Convenience callback, which always returns `true`.
static bool | never_selected (long, long)
| Convenience callback, which always returns `false`.
## Related Functions
(Note that these are not member functions.)
Gnome::Vte::Terminal* | wrap (VteTerminal* object, bool take_copy=false)
| A Glib::wrap() method for this object.

## Detailed Description

Terminal - a terminal emulator implemented as a gtkmm widget.

Examples:

  simple/main.cc.

## Member Typedef Documentation

typedef sigc::slot<bool, long , long > Gnome::Vte::Terminal::SlotSelectedCallback

For instance, bool on_selected(long column, long row);.

See also:
  get_text(), get_text_include_trailing_spaces(), get_text_range().

## Member Function Documentation

static bool Gnome::Vte::Terminal::always_selected | ( | long | ,
|  | long |
| ) |  | `[static]`

Convenience callback, which always returns `true`.

See also:
  get_text(), get_text_include_trailing_spaces(), get_text_range().

Examples:
  gettexter/main.cc.

void Gnome::Vte::Terminal::feed | ( | const Glib::ustring & | data | ) |

Interprets data as if it were data received from a child process.

This can either be used to drive the terminal without a child process, or just to mess with your users.

Parameters:

  data | A string in the terminal's current encoding.

void Gnome::Vte::Terminal::feed_child | ( | const Glib::ustring & | text | ) |

Sends a block of UTF-8 text to the child as if it were entered by the user at the keyboard.

Parameters:

  text | Data to send to the child.

void Gnome::Vte::Terminal::feed_child_binary | ( | const std::string & | data | ) |

Sends a block of binary data to the child.

Parameters:

  data | Data to send to the child.

Glib::Pid Gnome::Vte::Terminal::fork_command | ( | const std::string & | command = `std::string()`,
|  | const StdStringArrayHandle & | argv = `StdStringArrayHandle(0, Glib::OWNERSHIP_NONE)`,
|  | const StdStringArrayHandle & | envv = `StdStringArrayHandle(0, Glib::OWNERSHIP_NONE)`,
|  | const std::string & | directory = `std::string()`,
|  | bool | lastlog = `false`,
|  | bool | utmp = `false`,
|  | bool | wtmp = `false`
| ) |  |

Starts the specified command under a newly-allocated controlling pseudo-terminal.

The argv[0] is expected to be the name of the file being run, as it would be if execve() were being called. TERM is automatically set to reflect the terminal widget's emulation setting. If lastlog, utmp, or wtmp are `true`, logs the session to the specified system log files. argv and envv can be in two formats: with last string empty and with last string non-empty, so result of Glib::shell_parse_argv() or user-defined vector with all strings non-empty can be passed.

Parameters:

  command | The name of a binary to run, or empty string to get user's shell.
  argv | An argument list to be passed to command.
  envv | A list of environment variables to be added to the environment before starting command.
  directory | The name of a directory the command should start in, or empty string to inherit starting directory from parent.
  lastlog | `true` if the session should be logged to the lastlog.
  utmp | `true` if the session should be logged to the utmp/utmpx log.
  wtmp | `true` if the session should be logged to the wtmp/wtmpx log.

Returns:
  The ID of the new process.

Glib::Pid Gnome::Vte::Terminal::forkpty | ( | const StdStringArrayHandle & | envv = `StdStringArrayHandle(0, Glib::OWNERSHIP_NONE)`,
|  | const std::string & | directory = `std::string()`,
|  | bool | lastlog = `false`,
|  | bool | utmp = `false`,
|  | bool | wtmp = `false`
| ) |  |

Starts a new child process under a newly-allocated controlling pseudo-terminal.

TERM is automatically set to reflect the terminal widget's emulation setting. If lastlog, utmp, or wtmp are `true`, logs the session to the specified system log files. See fork_command() for description about format of envv parameter.

Parameters:

  envv | A list of environment variables to be added to the environment before starting returning in the child process.
  directory | The name of a directory the command should start in, or empty string to inherit starting directory from parent.
  lastlog | `true` if the session should be logged to the lastlog.
  utmp | `true` if the session should be logged to the utmp/utmpx log.
  wtmp | `true` if the session should be logged to the wtmp/wtmpx log.

Returns:
  The ID of the new process in the parent.

Gtk::Adjustment& Gnome::Vte::Terminal::get_adjustment | ( |  | ) |

Gets terminal's adjustment for use in scrollbar for example.

Returns:
  Terminal's adjustment.

const Gtk::Adjustment& Gnome::Vte::Terminal::get_adjustment | ( |  | ) | const

An accessor function provided for the benefit of language bindings.

Returns:
  The contents of terminal's adjustment field.

bool Gnome::Vte::Terminal::get_allow_bold | ( |  | ) | const

Checks whether or not the terminal will attempt to draw bold text by repainting text with a one-pixel offset.

Returns:
  `true` if bolding is enabled, `false` if not.

bool Gnome::Vte::Terminal::get_audible_bell | ( |  | ) | const

Checks whether or not the terminal will beep when the child outputs the "bl" sequence.

Returns:
  `true` if audible bell is enabled, `false` if not.

long Gnome::Vte::Terminal::get_char_height | ( |  | ) | const

Gets terminal's char height for use in Gdk::Geometry for example.

Returns:
  Terminal's char height.

long Gnome::Vte::Terminal::get_char_width | ( |  | ) | const

Gets terminal's char width for use in Gdk::Geometry for example.

Returns:
  Terminal's char width.

int Gnome::Vte::Terminal::get_child_exit_status | ( |  | ) | const

Gets the exit status of the command started by fork_command().

See your C library's documentation for more details on how to interpret the exit status.

Note that this function may only be called from the signal handler of the "child-exited" signal.

Returns:
  The child's exit status.

long Gnome::Vte::Terminal::get_column_count | ( |  | ) | const

Gets terminal's column count.

Returns:
  Terminal's column count.

TerminalCursorBlinkMode Gnome::Vte::Terminal::get_cursor_blink_mode | ( |  | ) | const

Gets cursor blink mode.

Returns:
  Cursor blink mode.

CursorPosition Gnome::Vte::Terminal::get_cursor_position | ( |  | ) | const

Reads the location of the insertion cursor and returns it.

The row coordinate is absolute.

Returns:
  Gnome::Vte::CursorPosition instance holding both coordinates.

TerminalCursorShape Gnome::Vte::Terminal::get_cursor_shape | ( |  | ) | const

Gets the shape of the cursor drawn.

Returns:
  The Gnome::Vte::TerminalCursorShape used to draw cursor.

Glib::ustring Gnome::Vte::Terminal::get_default_emulation | ( |  | ) | const

Queries the terminal for its default emulation, which is attempted if set_default_emulation() is used.

Returns:
  The name of the default terminal type the widget attempts to emulate.

Glib::ustring Gnome::Vte::Terminal::get_emulation | ( |  | ) | const

Queries the terminal for its current emulation, as last set by a call to set_emulation().

Returns:
  The name of the terminal type the widget is attempting to emulate.

std::string Gnome::Vte::Terminal::get_encoding | ( |  | ) | const

Determines the name of the encoding in which the terminal expects data to be encoded.

Returns:
  The current encoding for the terminal.

Pango::FontDescription Gnome::Vte::Terminal::get_font | ( |  | ) | const

Queries the terminal for information about the fonts which will be used to draw text in the terminal.

Returns:
  A Pango::FontDescription describing the font the terminal is currently using to render text.

bool Gnome::Vte::Terminal::get_has_selection | ( |  | ) | const

Checks if the terminal currently contains selected text.

Note that this is different from determining if the terminal is the owner of any Gtk::Clipboard items.

Returns:
  `true` if part of the text in the terminal is selected.

Glib::ustring Gnome::Vte::Terminal::get_icon_title | ( |  | ) | const

Gets terminal's icon title.

Returns:
  Terminal's icon title.

bool Gnome::Vte::Terminal::get_mouse_autohide | ( |  | ) | const

Determines the value of the terminal's mouse autohide setting.

When autohiding is enabled, the mouse cursor will be hidden when the user presses a key and shown when the user moves the mouse. This setting can be changed using set_mouse_autohide().

Returns:
  `true` if autohiding is enabled, `false` if not.

Padding Gnome::Vte::Terminal::get_padding | ( |  | ) | const

Determines the amount of additional space the widget is using to pad the edges of its visible area.

This is necessary for cases where characters in the selected font don't themselves include a padding area and the text itself would otherwise be contiguous with the window border. Applications which use the terminal's row count, column count, char height, and char width to set geometry hints using Gtk::Window::set_geometry_hints() will need to add this value to the base size. The values returned in Gnome::Vte::Padding are the total padding used in each direction, and do not need to be doubled.

Returns:
  Gnome::Vte::Padding instance holding both paddings.

Deprecated:
  Use "inner-border" style property instead.

int Gnome::Vte::Terminal::get_pty | ( |  | ) | const

Gets the file descriptor, or -1 if the terminal has no PTY.

Returns:
  The file descriptor, or -1 if the terminal has no PTY.

long Gnome::Vte::Terminal::get_row_count | ( |  | ) | const

Gets terminal's row count.

Returns:
  Terminal's row count.

Glib::ustring Gnome::Vte::Terminal::get_status_line | ( |  | ) | const

Some terminal emulations specify a status line which is separate from the main display area, and define a means for applications to move the cursor to the status line and back.

Returns:
  The current contents of the terminal's status line. For terminals like "xterm", this will usually be the empty string.

TextAndCharAttrs Gnome::Vte::Terminal::get_text | ( | const SlotSelectedCallback & | slot | ) | const

Extracts a view of the visible part of the terminal.

Characters will only be read if slot returns `true` after being passed the column and row, respectively. A Gnome::Vte::CharAttributes structure is added to Gnome::Vte::TextAndCharAttrs return value for each byte added to the returned string detailing the character's position, colors, and other characteristics. Remember: to get byte representation of gotten text, use std::string.

Parameters:

  slot | A slot for callback.

Returns:
  A Gnome::Vte::TextAndCharAttrs with text that may be empty and stored text attributes.

TextAndCharAttrs Gnome::Vte::Terminal::get_text_include_trailing_spaces | ( | const SlotSelectedCallback & | slot | ) | const

Extracts a view of the visible part of the terminal.

Characters will only be read if slot returns `true` after being passed the column and row, respectively. A Gnome::Vte::CharAttributes structure is added to Gnome::Vte::TextAndCharAttrs return value for each byte added to the returned string detailing the character's position, colors, and other characteristics. This function differs from get_text() in that trailing spaces at the end of lines are included. Remember: to get byte representation of gotten text, use std::string.

Parameters:

  slot | A slot for callback.

Returns:
  A Gnome::Vte::TextAndCharAttrs with text that may be empty and stored text attributes.

TextAndCharAttrs Gnome::Vte::Terminal::get_text_range | ( | long | start_row,
|  | long | start_col,
|  | long | end_row,
|  | long | end_col,
|  | const SlotSelectedCallback & | slot
| ) |  | const

Extracts a view of the visible part of the terminal.

Characters will only be read if slot returns `true` after being passed the column and row, respectively. A Gnome::Vte::CharAttributes structure is added to Gnome::Vte::TextAndCharAttrs return value for each byte added to the returned string detailing the character's position, colors, and other characteristics. The entire scrollback buffer is scanned, so it is possible to read the entire contents of the buffer using this function. Remember: to get byte representation of gotten text, use std::string.

Parameters:

  start_row | First row to search for data.
  start_col | First column to search for data.
  end_row | Last row to search for data.
  end_col | Last column to search for data.
  slot | A slot for callback.

Returns:
  A Gnome::Vte::TextAndCharAttrs with text that may be empty and stored text attributes.

bool Gnome::Vte::Terminal::get_visible_bell | ( |  | ) | const

Checks whether or not the terminal will present a visible bell to the user when the child outputs the "bl" sequence.

The terminal will clear itself to the default foreground color and then repaint itself.

Returns:
  `true` if visible bell is enabled, `false` if not.

Glib::ustring Gnome::Vte::Terminal::get_window_title | ( |  | ) | const

Gets terminal's window title.

Returns:
  Terminal's window title.

void Gnome::Vte::Terminal::im_append_menuitems | ( | Gtk::MenuShell & | menushell | ) |

Appends menu items for various input methods to the given menu.

The user can select one of these items to modify the input method used by the terminal.

Parameters:

  menushell | A Gtk::MenuShell.

bool Gnome::Vte::Terminal::is_word_char | ( | gunichar | c | ) |

Checks if a particular character is considered to be part of a word or not, based on the values last passed to set_word_chars().

Parameters:

  c | A candidate Unicode code point.

Returns:
  `true` if the character is considered to be part of a word.

int Gnome::Vte::Terminal::match_add_gregex | ( | Glib::RefPtr< Glib::Regex > | regex,
|  | Glib::RegexMatchFlags | flags
| ) |  |

Adds the regular expression regex to the list of matching expressions.

When the user moves the mouse cursor over a section of displayed text which matches this expression, the text will be highlighted.

Parameters:

  regex | A Glib::RefPtr<Glib::Regex>.
  flags | The Glib::RegexMatchFlags to use when matching the regex.

Returns:
  An integer associated with this expression.

Match Gnome::Vte::Terminal::match_check | ( | long | column,
|  | long | row
| ) |  |

Checks if the text in and around the specified position matches any of the regular expressions previously set using match_add_gregex().

If a match exists, the text string and the number associated with the matched regular expression is returned.

If more than one regular expression has been set with match_add_gregex(), then expressions are checked in the order in which they were added.

Parameters:

  column | The text column.
  row | The text row.

Returns:
  A Gnome::Vte::Match instance holding string which matches one of the previously set regular expressions and a tag of matched regular expression.

void Gnome::Vte::Terminal::match_remove | ( | int | tag | ) |

Removes the regular expression which is associated with the given tag from the list of expressions which the terminal will highlight when the user moves the mouse cursor over matching text.

Parameters:

  tag | The tag of the regex to remove.

void Gnome::Vte::Terminal::match_set_cursor | ( | int | tag,
|  | Gdk::Cursor & | cursor
| ) |  |

Sets which cursor the terminal will use if the pointer is over the pattern specified by tag.

The terminal keeps a reference to cursor.

Parameters:

  tag | The tag of the regex which should use the specified cursor.
  cursor | The Gdk::Cursor which the terminal should use when the pattern is highlighted.

void Gnome::Vte::Terminal::match_set_cursor_name | ( | int | tag,
|  | const Glib::ustring & | cursor_name
| ) |  |

Sets which cursor the terminal will use if the pointer is over the pattern specified by tag.

Parameters:

  tag | The tag of the regex which should use the specified cursor.
  cursor_name | The name of the cursor.

void Gnome::Vte::Terminal::match_set_cursor_type | ( | int | tag,
|  | Gdk::CursorType | cursor_type
| ) |  |

Sets which cursor the terminal will use if the pointer is over the pattern specified by tag.

Parameters:

  tag | The tag of the regex which should use the specified cursor.
  cursor_type | A Gdk::CursorType.

static bool Gnome::Vte::Terminal::never_selected | ( | long | ,
|  | long |
| ) |  | `[static]`

Convenience callback, which always returns `false`.

See also:
  get_text(), get_text_include_trailing_spaces(), get_text_range().

void Gnome::Vte::Terminal::paste_clipboard | ( |  | ) |

Sends the contents of the `GDK_SELECTION_CLIPBOARD` selection to the terminal's child.

If necessary, the data is converted from UTF-8 to the terminal's current encoding. It's called on paste menu item, or when user presses Shift+Insert.

void Gnome::Vte::Terminal::paste_primary | ( |  | ) |

Sends the contents of the `GDK_SELECTION_PRIMARY` selection to the terminal's child.

If necessary, the data is converted from UTF-8 to the terminal's current encoding. The terminal will call also paste the `GDK_SELECTION_PRIMARY` selection when the user clicks with the the second mouse button.

Glib::PropertyProxy<bool> Gnome::Vte::Terminal::property_allow_bold | ( |  | ) |

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy_ReadOnly<bool> Gnome::Vte::Terminal::property_allow_bold | ( |  | ) | const

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy<bool> Gnome::Vte::Terminal::property_audible_bell | ( |  | ) |

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy_ReadOnly<bool> Gnome::Vte::Terminal::property_audible_bell | ( |  | ) | const

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy<Glib::ustring> Gnome::Vte::Terminal::property_background_image_file | ( |  | ) |

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy_ReadOnly<Glib::ustring> Gnome::Vte::Terminal::property_background_image_file | ( |  | ) | const

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy_ReadOnly<Gdk::Pixbuf> Gnome::Vte::Terminal::property_background_image_pixbuf | ( |  | ) | const

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy<Gdk::Pixbuf> Gnome::Vte::Terminal::property_background_image_pixbuf | ( |  | ) |

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy<double> Gnome::Vte::Terminal::property_background_opacity | ( |  | ) |

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy_ReadOnly<double> Gnome::Vte::Terminal::property_background_opacity | ( |  | ) | const

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy<double> Gnome::Vte::Terminal::property_background_saturation | ( |  | ) |

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy_ReadOnly<double> Gnome::Vte::Terminal::property_background_saturation | ( |  | ) | const

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy_ReadOnly<Gdk::Color> Gnome::Vte::Terminal::property_background_tint_color | ( |  | ) | const

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy<Gdk::Color> Gnome::Vte::Terminal::property_background_tint_color | ( |  | ) |

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy<bool> Gnome::Vte::Terminal::property_background_transparent | ( |  | ) |

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy_ReadOnly<bool> Gnome::Vte::Terminal::property_background_transparent | ( |  | ) | const

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy<TerminalEraseBinding> Gnome::Vte::Terminal::property_backspace_binding | ( |  | ) |

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy_ReadOnly<TerminalEraseBinding> Gnome::Vte::Terminal::property_backspace_binding | ( |  | ) | const

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy<TerminalCursorBlinkMode> Gnome::Vte::Terminal::property_cursor_blink_mode | ( |  | ) |

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy_ReadOnly<TerminalCursorBlinkMode> Gnome::Vte::Terminal::property_cursor_blink_mode | ( |  | ) | const

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy<TerminalCursorShape> Gnome::Vte::Terminal::property_cursor_shape | ( |  | ) |

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy_ReadOnly<TerminalCursorShape> Gnome::Vte::Terminal::property_cursor_shape | ( |  | ) | const

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy<TerminalEraseBinding> Gnome::Vte::Terminal::property_delete_binding | ( |  | ) |

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy_ReadOnly<TerminalEraseBinding> Gnome::Vte::Terminal::property_delete_binding | ( |  | ) | const

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy<Glib::ustring> Gnome::Vte::Terminal::property_emulation | ( |  | ) |

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy_ReadOnly<Glib::ustring> Gnome::Vte::Terminal::property_emulation | ( |  | ) | const

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy<Glib::ustring> Gnome::Vte::Terminal::property_encoding | ( |  | ) |

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy_ReadOnly<Glib::ustring> Gnome::Vte::Terminal::property_encoding | ( |  | ) | const

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy<Pango::FontDescription> Gnome::Vte::Terminal::property_font_desc | ( |  | ) |

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy_ReadOnly<Pango::FontDescription> Gnome::Vte::Terminal::property_font_desc | ( |  | ) | const

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy_ReadOnly<Glib::ustring> Gnome::Vte::Terminal::property_icon_title | ( |  | ) | const

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy<bool> Gnome::Vte::Terminal::property_pointer_autohide | ( |  | ) |

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy_ReadOnly<bool> Gnome::Vte::Terminal::property_pointer_autohide | ( |  | ) | const

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy_ReadOnly<int> Gnome::Vte::Terminal::property_pty | ( |  | ) | const

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy<int> Gnome::Vte::Terminal::property_pty | ( |  | ) |

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy_ReadOnly<bool> Gnome::Vte::Terminal::property_scroll_background | ( |  | ) | const

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy<bool> Gnome::Vte::Terminal::property_scroll_background | ( |  | ) |

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy<bool> Gnome::Vte::Terminal::property_scroll_on_keystroke | ( |  | ) |

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy_ReadOnly<bool> Gnome::Vte::Terminal::property_scroll_on_keystroke | ( |  | ) | const

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy_ReadOnly<bool> Gnome::Vte::Terminal::property_scroll_on_output | ( |  | ) | const

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy<bool> Gnome::Vte::Terminal::property_scroll_on_output | ( |  | ) |

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy_ReadOnly<int> Gnome::Vte::Terminal::property_scrollback_lines | ( |  | ) | const

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy<int> Gnome::Vte::Terminal::property_scrollback_lines | ( |  | ) |

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy_ReadOnly<bool> Gnome::Vte::Terminal::property_visible_bell | ( |  | ) | const

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy<bool> Gnome::Vte::Terminal::property_visible_bell | ( |  | ) |

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy_ReadOnly<Glib::ustring> Gnome::Vte::Terminal::property_window_title | ( |  | ) | const

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy<Glib::ustring> Gnome::Vte::Terminal::property_word_chars | ( |  | ) |

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy_ReadOnly<Glib::ustring> Gnome::Vte::Terminal::property_word_chars | ( |  | ) | const

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

void Gnome::Vte::Terminal::reset | ( | bool | full,
|  | bool | clear_history
| ) |  |

Resets as much of the terminal's internal state as possible, discarding any unprocessed input data, resetting character attributes, cursor state, national character set state, status line, terminal modes (insert/delete), selection state, and encoding.

Parameters:

  full | `true` to reset tabstops.
  clear_history | `true` to empty the terminal's scrollback buffer.

void Gnome::Vte::Terminal::set_allow_bold | ( | bool | allow_bold = `true` | ) |

Controls whether or not the terminal will attempt to draw bold text, either by using a bold font variant or by repainting text with a different offset.

Parameters:

  allow_bold | `true` if the terminal should attempt to draw bold text.

void Gnome::Vte::Terminal::set_audible_bell | ( | bool | is_audible = `true` | ) |

Controls whether or not the terminal will beep when the child outputs the "bl" sequence.

Parameters:

  is_audible | `true` if the terminal should beep.

void Gnome::Vte::Terminal::set_background_image | ( | const Glib::RefPtr< Gdk::Pixbuf > & | image | ) |

Sets a background image for the widget.

Text which would otherwise be drawn using the default background color will instead be drawn over the specified image. If necessary, the image will be tiled to cover the widget's entire visible area. If specified by set_background_saturation(), the terminal will tint its in-memory copy of the image before applying it to the terminal. If image will be Glib::RefPtr<Gdk::PixBuf>() then background will be canceled (or just use unset_background_image()).

Parameters:

  image | A Glib::RefPtr<Gdk::Pixbuf> to use.

void Gnome::Vte::Terminal::set_background_image_file | ( | const std::string & | path | ) |

Sets a background image for the widget.

If specified by set_background_saturation(), the terminal will tint its in-memory copy of the image before applying it to the terminal.

Parameters:

  path | Path to an image file.

void Gnome::Vte::Terminal::set_background_saturation | ( | double | saturation | ) |

If a background image has been set using set_background_image(), set_background_image_file(), or set_background_transparent(), and the saturation value is less than 1.0, the terminal will adjust the colors of the image before drawing the image.

To do so, the terminal will create a copy of the background image (or snapshot of the root window) and modify its pixel values.

Parameters:

  saturation | A floating point value between 0.0 and 1.0.

void Gnome::Vte::Terminal::set_background_tint_color | ( | const Gdk::Color & | color | ) |

If a background image has been set using set_background_image(), set_background_image_file(), or set_background_transparent(), and the value set by set_background_saturation() is less than one, the terminal will adjust the color of the image before drawing the image.

To do so, the terminal will create a copy of the background image (or snapshot of the root window) and modify its pixel values. The initial tint color is black.

Parameters:

  color | A color which the terminal background should be tinted to if its saturation is not 1.0.

void Gnome::Vte::Terminal::set_background_transparent | ( | bool | transparent = `true` | ) |

Sets the terminal's background image to the pixmap stored in the root window, adjusted so that if there are no windows below your application, the widget will appear to be transparent.

Parameters:

  transparent | `true` if the terminal should fake transparency.

void Gnome::Vte::Terminal::set_backspace_binding | ( | TerminalEraseBinding | binding | ) |

Modifies the terminal's backspace key binding, which controls what string or control sequence the terminal sends to its child when the user presses the backspace key.

Parameters:

  binding | A Vte::TerminalEraseBinding for the backspace key.

void Gnome::Vte::Terminal::set_color_background | ( | const Gdk::Color & | background | ) |

Sets the background color for text which does not have a specific background color assigned.

Only has effect when no background image is set and when the terminal is not transparent.

Parameters:

  background | The new background color.

void Gnome::Vte::Terminal::set_color_bold | ( | const Gdk::Color & | bold | ) |

Sets the color used to draw bold text in the default foreground color.

Parameters:

  bold | The new bold color.

void Gnome::Vte::Terminal::set_color_cursor | ( | const Gdk::Color & | cursor_background | ) |

Sets the background color for text which is under the cursor.

Parameters:

  cursor_background | The new color to use for the text cursor.

void Gnome::Vte::Terminal::set_color_dim | ( | const Gdk::Color & | dim | ) |

Sets the color used to draw dim text in the default foreground color.

Parameters:

  dim | The new dim color.

void Gnome::Vte::Terminal::set_color_foreground | ( | const Gdk::Color & | foreground | ) |

Sets the foreground color used to draw normal text.

Parameters:

  foreground | The new foreground color.

void Gnome::Vte::Terminal::set_color_highlight | ( | const Gdk::Color & | highlight_background | ) |

Sets the background color for text which is highlighted.

Parameters:

  highlight_background | The new color to use for highlighted text.

void Gnome::Vte::Terminal::set_colors | ( | const Gdk::Color & | foreground,
|  | const Gdk::Color & | background,
|  | const Gdk::ArrayHandle_Color & | palette
| ) |  |

The terminal widget uses a 28-color model comprised of the default foreground and background colors, the bold foreground color, the dim foreground color, an eight color palette, bold versions of the eight color palette, and a dim version of the the eight color palette.

Size of palette must be either 0, 8, 16, or 24. If size of palette is 8 or 16, the third (dim) and possibly the second (bold) 8-color palettes are extrapolated from the new background color and the items in palette.

Parameters:

  foreground | The new foreground color.
  background | The new background color.
  palette | The color palette.

void Gnome::Vte::Terminal::set_cursor_blink_mode | ( | TerminalCursorBlinkMode | mode | ) |

Sets whether or not the cursor will blink.

Using Gnome::Vte::CURSOR_BLINK_SYSTEM will use the Gtk::Settings::property_gtk_cursor_blink() setting.

Parameters:

  mode | The Gnome::Vte::TerminalCursorBlinkMode to use.

void Gnome::Vte::Terminal::set_cursor_shape | ( | TerminalCursorShape | shape | ) |

Sets the shape of the cursor drawn.

Parameters:

  shape | The Gnome::Vte::TerminalCursorShape to use.

void Gnome::Vte::Terminal::set_default_colors | ( | const Gdk::ArrayHandle_Color & | palette | ) |

The terminal widget uses a 28-color model comprised of the default foreground and background colors, the bold foreground color, the dim foreground color, an eight color palette, bold versions of the eight color palette, and a dim version of the the eight color palette.

Size of palette must be either 0, 8, 16, or 24. If size of palette is greater than 0, the new foreground color is taken from palette[7] and the new background color is taken from palette[0]. If size of palette is 8 or 16, the third (dim) and possibly the second (bold) 8-color palettes are extrapolated from the new background color and the items in palette.

Parameters:

  palette | The color palette

void Gnome::Vte::Terminal::set_delete_binding | ( | TerminalEraseBinding | binding | ) |

Modifies the terminal's delete key binding, which controls what string or control sequence the terminal sends to its child when the user presses the delete key.

Parameters:

  binding | A Vte::TerminalEraseBinding for the delete key.

void Gnome::Vte::Terminal::set_emulation | ( | const Glib::ustring & | emulation | ) |

Sets what type of terminal the widget attempts to emulate by scanning for control sequences defined in the system's termcap file.

Unless you are interested in this feature, always use "xterm".

Parameters:

  emulation | The name of a terminal description.

void Gnome::Vte::Terminal::set_encoding | ( | const std::string & | codeset | ) |

Changes the encoding the terminal will expect data from the child to be encoded with.

For certain terminal types, applications executing in the terminal can change the encoding. The default encoding is defined by the application's locale settings.

Parameters:

  codeset | A valid Glib::IConv encoding.

void Gnome::Vte::Terminal::set_font | ( | const Pango::FontDescription & | font_desc | ) |

Sets the font used for rendering all text displayed by the terminal, overriding any fonts set using Gtk::Widget::modify_font().

The terminal will immediately attempt to load the desired font, retrieve its metrics, and attempt to resize itself to keep the same number of rows and columns.

Parameters:

  font_desc | The Pango::FontDescription of the desired font.

void Gnome::Vte::Terminal::set_font_from_string | ( | const Glib::ustring & | name | ) |

A convenience function which converts name into a Pango::FontDescription and passes it to set_font().

Parameters:

  name | A string describing the font.

void Gnome::Vte::Terminal::set_mouse_autohide | ( | bool | setting = `true` | ) |

Changes the value of the terminal's mouse autohide setting.

When autohiding is enabled, the mouse cursor will be hidden when the user presses a key and shown when the user moves the mouse. This setting can be read using get_mouse_autohide().

Parameters:

  setting | `true` if the autohide should be enabled.

void Gnome::Vte::Terminal::set_opacity | ( | guint16 | opacity | ) |

Sets the opacity of the terminal background, were 0 means completely transparent and 65535 means completely opaque.

Parameters:

  opacity | The new opacity.

void Gnome::Vte::Terminal::set_pty | ( | int | pty_master | ) |

Attach an existing PTY master side to the terminal widget.

Use instead of fork_command() or forkpty().

Parameters:

  pty_master | A file descriptor of the master end of a PTY.

void Gnome::Vte::Terminal::set_scroll_background | ( | bool | scroll = `true` | ) |

Controls whether or not the terminal will scroll the background image (if one is set) when the text in the window must be scrolled.

Parameters:

  scroll | `true` if the terminal should scroll the background image along with text.

void Gnome::Vte::Terminal::set_scroll_on_keystroke | ( | bool | scroll = `true` | ) |

Controls whether or not the terminal will forcibly scroll to the bottom of the viewable history when the user presses a key.

Modifier keys do not trigger this behavior.

Parameters:

  scroll | `true` if the terminal should scroll on keystrokes.

void Gnome::Vte::Terminal::set_scroll_on_output | ( | bool | scroll = `true` | ) |

Controls whether or not the terminal will forcibly scroll to the bottom of the viewable history when the new data is received from the child.

Parameters:

  scroll | `true` if the terminal should scroll on output.

void Gnome::Vte::Terminal::set_scrollback_lines | ( | long | lines | ) |

Sets the length of the scrollback buffer used by the terminal.

The size of the scrollback buffer will be set to the larger of this value and the number of visible rows the widget can display, so 0 can safely be used to disable scrollback.

A negative value means "infinite scrollback".

Note that this setting only affects the normal screen buffer. For terminal types which have an alternate screen buffer, no scrollback is allowed on the alternate screen buffer.

Parameters:

  lines | The length of the history buffer.

void Gnome::Vte::Terminal::set_size | ( | long | columns,
|  | long | rows
| ) |  |

Attempts to change the terminal's size in terms of rows and columns.

If the attempt succeeds, the widget will resize itself to the proper size.

Parameters:

  columns | The desired number of columns.
  rows | The desired number of rows.

void Gnome::Vte::Terminal::set_visible_bell | ( | bool | is_visible = `true` | ) |

Controls whether or not the terminal will present a visible bell to the user when the child outputs the "bl" sequence.

The terminal will clear itself to the default foreground color and then repaint itself.

Parameters:

  is_visible | `true` if the terminal should flash.

void Gnome::Vte::Terminal::set_word_chars | ( | const Glib::ustring & | spec | ) |

When the user double-clicks to start selection, the terminal will extend the selection on word boundaries.

It will treat characters included in spec as parts of words, and all other characters as word separators. Ranges of characters can be specified by separating them with a hyphen.

As a special case, if spec is empty string, the terminal will treat all graphic non-punctuation non-space characters as word characters.

Parameters:

  spec | A specification.

Glib::SignalProxy0< void > Gnome::Vte::Terminal::signal_beep | ( |  | ) |

Prototype:
  `void on_my_beep()`

Glib::SignalProxy2< void,guint,guint > Gnome::Vte::Terminal::signal_char_size_changed | ( |  | ) |

Prototype:
  `void on_my_char_size_changed(guint char_width, guint char_height)`

Glib::SignalProxy0< void > Gnome::Vte::Terminal::signal_child_exited | ( |  | ) |

Prototype:
  `void on_my_child_exited()`

Glib::SignalProxy0< void > Gnome::Vte::Terminal::signal_contents_changed | ( |  | ) |

Prototype:
  `void on_my_contents_changed()`

Glib::SignalProxy0< void > Gnome::Vte::Terminal::signal_copy_clipboard | ( |  | ) |

Prototype:
  `void on_my_copy_clipboard()`

Glib::SignalProxy0< void > Gnome::Vte::Terminal::signal_cursor_moved | ( |  | ) |

Prototype:
  `void on_my_cursor_moved()`

Glib::SignalProxy0< void > Gnome::Vte::Terminal::signal_decrease_font_size | ( |  | ) |

Prototype:
  `void on_my_decrease_font_size()`

Glib::SignalProxy0< void > Gnome::Vte::Terminal::signal_deiconify_window | ( |  | ) |

Prototype:
  `void on_my_deiconify_window()`

Glib::SignalProxy0< void > Gnome::Vte::Terminal::signal_emulation_changed | ( |  | ) |

Prototype:
  `void on_my_emulation_changed()`

Glib::SignalProxy0< void > Gnome::Vte::Terminal::signal_encoding_changed | ( |  | ) |

Prototype:
  `void on_my_encoding_changed()`

Glib::SignalProxy0< void > Gnome::Vte::Terminal::signal_eof | ( |  | ) |

Prototype:
  `void on_my_eof()`

Glib::SignalProxy0< void > Gnome::Vte::Terminal::signal_icon_title_changed | ( |  | ) |

Prototype:
  `void on_my_icon_title_changed()`

Glib::SignalProxy0< void > Gnome::Vte::Terminal::signal_iconify_window | ( |  | ) |

Prototype:
  `void on_my_iconify_window()`

Glib::SignalProxy0< void > Gnome::Vte::Terminal::signal_increase_font_size | ( |  | ) |

Prototype:
  `void on_my_increase_font_size()`

Glib::SignalProxy0< void > Gnome::Vte::Terminal::signal_lower_window | ( |  | ) |

Prototype:
  `void on_my_lower_window()`

Glib::SignalProxy0< void > Gnome::Vte::Terminal::signal_maximize_window | ( |  | ) |

Prototype:
  `void on_my_maximize_window()`

Glib::SignalProxy2< void,guint,guint > Gnome::Vte::Terminal::signal_move_window | ( |  | ) |

Prototype:
  `void on_my_move_window(guint x, guint y)`

Glib::SignalProxy0< void > Gnome::Vte::Terminal::signal_paste_clipboard | ( |  | ) |

Prototype:
  `void on_my_paste_clipboard()`

Glib::SignalProxy0< void > Gnome::Vte::Terminal::signal_raise_window | ( |  | ) |

Prototype:
  `void on_my_raise_window()`

Glib::SignalProxy0< void > Gnome::Vte::Terminal::signal_refresh_window | ( |  | ) |

Prototype:
  `void on_my_refresh_window()`

Glib::SignalProxy2< void,guint,guint > Gnome::Vte::Terminal::signal_resize_window | ( |  | ) |

Prototype:
  `void on_my_resize_window(guint width, guint height)`

Glib::SignalProxy0< void > Gnome::Vte::Terminal::signal_restore_window | ( |  | ) |

Prototype:
  `void on_my_restore_window()`

Glib::SignalProxy0< void > Gnome::Vte::Terminal::signal_selection_changed | ( |  | ) |

Prototype:
  `void on_my_selection_changed()`

Glib::SignalProxy2< void,Gtk::Adjustment&,Gtk::Adjustment& > Gnome::Vte::Terminal::signal_set_scroll_adjustments | ( |  | ) |

Prototype:
  `void on_my_set_scroll_adjustments(Gtk::Adjustment& hadjustment, Gtk::Adjustment& vadjustment)`

Glib::SignalProxy0< void > Gnome::Vte::Terminal::signal_status_line_changed | ( |  | ) |

Prototype:
  `void on_my_status_line_changed()`

Glib::SignalProxy0< void > Gnome::Vte::Terminal::signal_text_deleted | ( |  | ) |

Prototype:
  `void on_my_text_deleted()`

Glib::SignalProxy0< void > Gnome::Vte::Terminal::signal_text_inserted | ( |  | ) |

Prototype:
  `void on_my_text_inserted()`

Glib::SignalProxy0< void > Gnome::Vte::Terminal::signal_text_modified | ( |  | ) |

Prototype:
  `void on_my_text_modified()`

Glib::SignalProxy1< void,int > Gnome::Vte::Terminal::signal_text_scrolled | ( |  | ) |

Prototype:
  `void on_my_text_scrolled(int delta)`

Glib::SignalProxy0< void > Gnome::Vte::Terminal::signal_window_title_changed | ( |  | ) |

Prototype:
  `void on_my_window_title_changed()`

void Gnome::Vte::Terminal::unset_background_image | ( |  | ) |

Convenience method which cancels background image.

Equivalent to set_background_image(Glib::RefPtr<Gdk::Pixbuf>()).

bool Gnome::Vte::Terminal::write_contents | ( | const Glib::RefPtr< Gio::OutputStream > & | stream,
|  | const Glib::RefPtr< Gio::Cancellable > & | cancellable,
|  | TerminalWriteFlags | flags = `TERMINAL_WRITE_DEFAULT`
| ) |  |

Write contents of the current contents of terminal (including any scrollback history) to stream according to flags.

The operation can be cancelled by triggering the cancellable object from another thread. If the operation was cancelled, the Gio::Error with CANCELLED will be thrown.

This is a synchronous operation and will make the widget (and input processing) during the write operation, which may take a long time depending on scrollback history and stream availability for writing.

Parameters:

  stream | A Gio::OutputStream to write to.
  cancellable | Optional Gio::Cancellable object.
  flags | A set of TerminalWriteFlags.

Returns:
  `true` on success, `false` if there was an error.

Since libvtemm 0.24:

bool Gnome::Vte::Terminal::write_contents | ( | const Glib::RefPtr< Gio::OutputStream > & | stream,
|  | TerminalWriteFlags | flags = `TERMINAL_WRITE_DEFAULT`
| ) |  |

Write contents of the current contents of terminal (including any scrollback history) to stream according to flags.

This is a synchronous operation and will make the widget (and input processing) during the write operation, which may take a long time depending on scrollback history and stream availability for writing.

Parameters:

  stream | A Gio::OutputStream to write to.
  flags | A set of TerminalWriteFlags.

Returns:
  `true` on success, `false` if there was an error.

Since libvtemm 0.24:

## Friends And Related Function Documentation

Gnome::Vte::Terminal* wrap | ( | VteTerminal * | object,
|  | bool | take_copy = `false`
| ) |  | `[related]`

A Glib::wrap() method for this object.

Parameters:

  object | The C instance.
  take_copy | False if the result should take ownership of the C instance. True if it should take a new copy or ref.

Returns:
  A C++ instance that wraps this C instance.